angular.module("two_player_timetapper", ["ionic","ionMdInput","ionic-material","ionic.rating","ionicLazyLoad","two_player_timetapper.controllers", "two_player_timetapper.services", "pascalprecht.translate"])
	.run(function($ionicPlatform, $translate) {
		$ionicPlatform.ready(function() {
			if(window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);
			}

			if(window.StatusBar) {
				StatusBar.styleDefault();
			}

			setTimeout(function() {
			}, 100);

			// get device language from cordova plugin and set translation
			if(typeof navigator.globalization !== "undefined") {
                navigator.globalization.getPreferredLanguage(function(language) {
                    $translate.use((language.value).split("-")[0]).then(function(data) {
                        console.log("SUCCESS -> " + data);
                    }, function(error) {
                        console.log("ERROR -> " + error);
                    });
                }, null);
            }


			//====== AdMob Code Start =============
			var admobid = {};
			  // select the right Ad Id according to platform
			  if( /(android)/i.test(navigator.userAgent) ) {
				  admobid = { // for Android
					  //banner: 'ca-app-pub-4543000274312570/2006413843',
					  interstitial: 'ca-app-pub-4543000274312570/5723969446'
				  };
			  } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
				  admobid = { // for iOS
					  //banner: 'ca-app-pub-6869992474017983/4806197152',
					  //interstitial: 'ca-app-pub-6869992474017983/7563979554'
				  };
			  } else {
				  admobid = { // for Windows Phone
					  //banner: 'ca-app-pub-6869992474017983/8878394753',
					  //interstitial: 'ca-app-pub-6869992474017983/1355127956'
				  };
			  }

			//if(window.AdMob) AdMob.createBanner( {
			//	adId:admobid.banner,
			//	position:AdMob.AD_POSITION.TOP_CENTER,
			//	autoShow:true
			//} );

			//	init interstitial
			if(window.AdMob) AdMob.prepareInterstitial({
				adId:admobid.interstitial,
				//isTesting:true,//comment this out before publishing the app
				autoShow:false
			});
			
			//======= AdMob Code End =======

		});
	})


	.filter("to_trusted", ["$sce", function($sce){
		return function(text) {
			return $sce.trustAsHtml(text);
		};
	}])
	.filter("trustUrl", function($sce) {
		return function(url) {
			return $sce.trustAsResourceUrl(url);
		};
	})




.config(function($stateProvider, $urlRouterProvider,$sceDelegateProvider, $translateProvider) {

	// Domain Whitelist
	$sceDelegateProvider.resourceUrlWhitelist([
		"self",
		new RegExp('^(http[s]?):\/\/(w{3}.)?youtube\.com/.+$'),
		new RegExp('^(http[s]?):\/\/(w{3}.)?w3schools\.com/.+$'),
	]);
	$stateProvider

	.state("about", {
		url: "/about",
		templateUrl:"templates/about.html",
		controller: "aboutCtrl"
	})

	.state("game", {
		url: "/game",
		cache: false,	// set cache to false in order to clear view on each view change
		templateUrl:"templates/game.html",
		controller: "gameCtrl"
	})

	.state("how_to_play", {
		url: "/how_to_play",
		templateUrl:"templates/how_to_play.html",
		controller: "how_to_playCtrl"
	})

	.state("options", {
		url: "/settings",
		templateUrl:"templates/options.html",
		controller: "optionsCtrl"
	})

	.state("start", {
		url: "/start",
		templateUrl:"templates/start.html",
		controller: "startCtrl"
	})

	$urlRouterProvider.otherwise("/start");


	/*
	 *	Set and load translations
	 */
	$translateProvider.useStaticFilesLoader({
		prefix: 'languages/locale-',
		suffix: '.json'
	});
	//$translateProvider.uses('en');

	$translateProvider.preferredLanguage("en");
    $translateProvider.fallbackLanguage("en");
	$translateProvider.useSanitizeValueStrategy('sanitize');


});
