angular.module("two_player_timetapper.controllers")

.controller("gameCtrl", function($scope,$rootScope,$compile,$state,$ionicScrollDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$ionicLoading,$ionicPopup,$ionicPopover,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$translate,$ionicPlatform,$interval){

    //$translate.use('de');

	//$ionicHistory.clearCache().then(function(){ $state.go('game') })

	$rootScope.page_id = "game" ;
	$scope.scrollTop = function(){
		$ionicScrollDelegate.$getByHandle("top").scrollTop();
	};
	// open external browser
	$scope.openURL = function($url){
		window.open($url,"_system","location=yes");
	};
	// open AppBrowser
	$scope.openAppBrowser = function($url){
		window.open($url,"_blank","closebuttoncaption=Done");
	};
	// open WebView
	$scope.openWebView = function($url){
		window.open($url,"_self");
	};

	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);


	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	$scope.rating = {};
	$scope.rating.max = 5;



  /* ==============
  	  GAME VARIABLES
  	  =================*/

	/*
	*  set global settings object vars
	*/
	$scope.settings = {
		players			: 1,
		minRoundTime	: 5,
		maxRoundTime	: 80,
		roundTimeout  	: '',
		roundTime     	: 0,
		totalRounds		: 0,
		maxBatteryTime	: 40,
		gameEnabled   	: false,
		gameFinished	: false,
		gamePause		: false,
		showAds			: true
	};


  /*
  * get vars from localstorage - minRoundTime
  */
  if (localStorage.getItem("minRoundTime") === null) {

    localStorage.setItem("minRoundTime", $scope.settings.minRoundTime);

  } else{

    $scope.settings.minRoundTime = parseInt(localStorage.getItem("minRoundTime"));

  }


  /*
  * get vars from localstorage - maxRoundTime
  */
  if (localStorage.getItem("maxRoundTime") === null) {

    localStorage.setItem("maxRoundTime", $scope.settings.maxRoundTime);

  } else{

    $scope.settings.maxRoundTime = parseInt(localStorage.getItem("maxRoundTime"));

  }


  /*
  * get vars from localstorage - total rounds
  */
/*
  if (localStorage.getItem("totalRounds") === null) {

    localStorage.setItem("totalRounds", $scope.settings.totalRounds);

  } else{

    $scope.settings.totalRounds = parseInt(localStorage.getItem("totalRounds"));

  }
*/


	/*
	*	set global player object vars
	*/
	$scope.player = {

		1	: {
			name			: '',
			score			: 0,
			batteryElement: document.getElementById('battery-state-loading-1'),
			batteryTime		: 0,
			timeout			: '',
			roundsWon		: 0,
			wonThisRound	: false,
			newTouchField	: '',
			lastTouchField	: '',
			charging		: false,
			tapActivated	: false,

			badgeStart    : document.getElementById('badge-start-player-1'),
			badgeEnd      : document.getElementById('badge-end-player-1'),
		},

		2	: {
			name			: '',
			score			: 0,
			batteryElement: document.getElementById('battery-state-loading-2'),
			batteryTime		: 0,
			timeout			: '',
			roundsWon		: 0,
			wonThisRound	: false,
			newTouchField	: '',
			lastTouchField	: '',
			charging		: false,
			tapActivated	: false,

			badgeStart    : document.getElementById('badge-start-player-2'),
			badgeEnd      : document.getElementById('badge-end-player-2'),
		},

	}

	/*
	* get vars from localstorage - player 1 name
	*/
	if (localStorage.getItem("playerOneName") === null) {

	  localStorage.setItem("playerOneName", $scope.player[1].name);

	} else{

	  $scope.player[1].name = localStorage.getItem("playerOneName");

	}

	/*
	* get vars from localstorage - player 2 name
	*/
	if (localStorage.getItem("playerTwoName") === null) {

	  localStorage.setItem("playerTwoName", $scope.player[2].name);

	} else{

	  $scope.player[2].name = localStorage.getItem("playerTwoName");

	}
	



	/* ==============
  	  GAME FUNCTIONS
  	  =================*/

	/*
	* init game configurations
	*/
	$scope.gameInit = function() {

		// set round time
		if($scope.settings.minRoundTime != $scope.settings.maxRoundTime){

  		//  catch wrong user input if min time is higher than max time
  		if($scope.settings.minRoundTime > $scope.settings.maxRoundTime){

    		$scope.settings.maxRoundTime = $scope.settings.minRoundTime
    		localStorage.setItem("maxRoundTime", $scope.settings.maxRoundTime);

  		}

  		$scope.settings.roundTime = $scope.getRandomInt(parseInt($scope.settings.minRoundTime), parseInt($scope.settings.maxRoundTime));

		} else{

  		$scope.settings.roundTime = parseInt($scope.settings.maxRoundTime);

		}

		// set max battery time
		$scope.settings.maxBatteryTime = Math.floor(parseInt($scope.settings.maxRoundTime) / 2);

	}
	
	
	
	/*
	* show ads in game
	*/
	$scope.gameContinueShowAd = function() {
		
		// check round number to display ads or not
		var roundNumberIsOdd = $scope.isOdd($scope.settings.totalRounds);		

		// check and show interstitial (if round number is even 2,4,6...)
		if (window.AdMob && !roundNumberIsOdd && $scope.settings.showAds){
			//alert ('windowAdmob: gameShowAd');
			
			AdMob.isInterstitialReady(function(isready){
				if(isready){
					//alert ('isInterstitialReady showInterstitial');
					$scope.settings.gamePause = true;
					AdMob.showInterstitial();
				}  else {
					//alert ('no isInterstitialReady gameContinue');
					$scope.gameContinue();
				}
			});
			
		} else {
			//alert ('no windowAdmob gameContinue');
			$scope.gameContinue();
		}
		
	}


	/*
	* continue game
	*/
	$scope.gameContinue = function() {
				
		$scope.gameReset();

		// set round time
		if($scope.settings.minRoundTime != $scope.settings.maxRoundTime){

			$scope.settings.roundTime = $scope.getRandomInt(parseInt($scope.settings.minRoundTime), parseInt($scope.settings.maxRoundTime));

		} else{

			$scope.settings.roundTime = parseInt($scope.settings.maxRoundTime);

		}

		// set max battery time
		$scope.settings.maxBatteryTime = Math.floor(parseInt($scope.settings.maxRoundTime) / 2);


		//  un-finish game
		$scope.settings.gameFinished = false;
		
		//$scope.$apply();
		$scope.$applyAsync();

		//	start game
		$scope.gameStart();

	}


	/*
	* start game
	*/
	$scope.gameStart = function() {

		//  show start badge
		$scope.player[1].badgeStart.classList.remove("hide-opacity");
		$scope.player[2].badgeStart.classList.remove("hide-opacity");
		$scope.player[1].badgeEnd.classList.add("hide-opacity");
		$scope.player[2].badgeEnd.classList.add("hide-opacity");
	
		// increase round
		$scope.settings.totalRounds ++;
	
		//  start game after 3 seconds
		setTimeout( function() {
	
			//  hide start badge
		  $scope.player[1].badgeStart.classList.add("hide-opacity");
		  $scope.player[2].badgeStart.classList.add("hide-opacity");
	
		  //  start all game activity
		  $scope.settings.gameEnabled = true;
	
		  //	decrease roundTime count every second
			$scope.settings.roundTimeout = setInterval(function () {
	
				if($scope.settings.roundTime > 0){
	
					$scope.settings.roundTime = $scope.settings.roundTime - 1;
	
				} else{
	
					clearTimeout($scope.settings.roundTimeout);
	
					// finish game when time is up
					$scope.gameOver();
	
				}
	
				//console.log('round time: ' + $scope.settings.roundTime);
	
			}, 1000);
	
			$scope.$apply();
	
		}, 3000);

	}


	/*
  * finish game
	*/
	$scope.gameOver = function() {

		//  stop all game activity
		$scope.settings.gameEnabled = false;

		//	hide charging text
		$scope.player[1].charging = false;
		$scope.player[2].charging = false;

		//  show finish badge
		$scope.player[1].badgeStart.classList.add("hide-opacity");
		$scope.player[2].badgeStart.classList.add("hide-opacity");
		$scope.player[1].badgeEnd.classList.remove("hide-opacity");
		$scope.player[2].badgeEnd.classList.remove("hide-opacity");

		//  finish game after 3 seconds
		setTimeout( function() {

			//  finish game
			$scope.settings.gameFinished = true;

			// set statistics
			if($scope.player[1].score > $scope.player[2].score){

				$scope.player[1].wonThisRound = true;
				$scope.player[1].roundsWon ++;

				$scope.player[2].wonThisRound = false;

			} else if($scope.player[1].score < $scope.player[2].score){

				$scope.player[2].wonThisRound = true;
				$scope.player[2].roundsWon ++;

				$scope.player[1].wonThisRound = false;

			} else{

  			$scope.player[1].wonThisRound = false;
  			$scope.player[2].wonThisRound = false;

			}

			//$scope.settings.totalRounds ++;

			$scope.$apply();

		}, 3000);

		$scope.$apply();

	}


	/*
	* reset game
	*/
	$scope.gameReset = function() {

		//  stop all game activity
		$scope.settings.gameEnabled = false;

		//  clear round time
		clearTimeout($scope.settings.roundTimeout);

		// clear payers battery timeout
		clearTimeout($scope.player[1].timeout);
		clearTimeout($scope.player[2].timeout);

		//	reset scores
		$scope.player[1].score = 0;
		$scope.player[2].score = 0;

		//	reset battery times
		$scope.player[1].batteryTime = 0;
		$scope.player[2].batteryTime = 0;
		$scope.player[1].batteryElement.style.height = 0;
		$scope.player[2].batteryElement.style.height = 0;
		
		$scope.$applyAsync();
		//$scope.$apply();

	}


	/* ==============
	  PLAYER 1
	  =================*/

	/*
	*	handle touch field action - player 1
	*/
	$scope.playerOneTouch = function(touchField) {

		$scope.player[1].newTouchField = touchField;

		//	check that fields are activated alternated and battery time is available
		if( $scope.player[1].newTouchField != $scope.player[1].lastTouchField &&
			$scope.player[1].batteryTime > 0 ){

			//	increase score
			$scope.player[1].score = $scope.player[1].score + 1;

			//	set new touched field to last touched field
			$scope.player[1].lastTouchField = $scope.player[1].newTouchField;
		}

	}


	/*
	*	handle battery field load action - player 1
	*/
	$scope.playerOneLoadBattery = function() {

		// clear timeout (if any from touchend event)
		clearTimeout($scope.player[1].timeout);

		//	show charging text
		$scope.player[1].charging = true;

		//	activate tabs
		$scope.player[1].tapActivated = true;

		//	increase time count every second
		$scope.player[1].timeout = setInterval(function loadPlayerOne() {

			if($scope.settings.gameEnabled){

				if($scope.player[1].batteryTime <= $scope.settings.maxBatteryTime){

					// increase battery seconds
					$scope.player[1].batteryTime = $scope.player[1].batteryTime + 1;
					//	increase battery height visibility by percentage of max battery time (5 + because of border from design)
					$scope.player[1].batteryElement.style.height = "calc(4% + " + ($scope.player[1].batteryTime * (100/$scope.settings.maxBatteryTime)) + "%)";

				}

			} else{

				clearTimeout($scope.player[1].timeout);

			}

			//console.log('battery time: ' + $scope.player[1].batteryTime);

			return loadPlayerOne;

		}(), 1000);

	}


	/*
	*	handle battery field unload action - player 1
	*/
	$scope.playerOneUnloadBattery = function() {

		// clear timeout (if any from touchstart event)
		clearTimeout($scope.player[1].timeout);

		//	hide charging text
		$scope.player[1].charging = false;

		//	decrease time count every second
		$scope.player[1].timeout = setInterval(function unloadPlayerOne() {

			if($scope.player[1].batteryTime > 0 && $scope.settings.gameEnabled){

				$scope.player[1].batteryTime = $scope.player[1].batteryTime - 1;
				$scope.player[1].batteryElement.style.height = "calc(4% + " + ($scope.player[1].batteryTime * (100/$scope.settings.maxBatteryTime)) + "%)";

			} else{

				//	deactivate tabs
				$scope.player[1].tapActivated = false;

				//	set height to 0%
				$scope.player[1].batteryElement.style.height = 0;

				clearTimeout($scope.player[1].timeout);

				$scope.$apply();

			}

			//console.log('battery time: ' +$scope.player[1].batteryTime);

			return unloadPlayerOne;

		}(), 1000);

	}


  /* ==============
	  PLAYER 2
	  =================*/

	/*
	*	handle touch field action - player 1
	*/
	$scope.playerTwoTouch = function(touchField) {

		$scope.player[2].newTouchField = touchField;

		//	check that fields are activated alternated and battery time is available
		if( $scope.player[2].newTouchField != $scope.player[2].lastTouchField &&
			$scope.player[2].batteryTime > 0 ){

			//	increase score
			$scope.player[2].score = $scope.player[2].score + 1;

			//	set new touched field to last touched field
			$scope.player[2].lastTouchField = $scope.player[2].newTouchField;
		}

	}


	/*
	*	handle battery field load action - player 1
	*/
	$scope.playerTwoLoadBattery = function() {

		// clear timeout (if any from touchend event)
		clearTimeout($scope.player[2].timeout);

		//	show charging text
		$scope.player[2].charging = true;

		//	activate tabs
		$scope.player[2].tapActivated = true;

		//	increase time count every second
		$scope.player[2].timeout = setInterval(function loadPlayerTwo() {

			if($scope.settings.gameEnabled){

				$scope.player[2].batteryTime = $scope.player[2].batteryTime + 1;
				$scope.player[2].batteryElement.style.height = "calc(4% + " + ($scope.player[2].batteryTime * (100/$scope.settings.maxBatteryTime)) + "%)";

			} else{

				// clear timeout (if any from touchstart event)
				clearTimeout($scope.player[1].timeout);

			}

			//console.log('battery time: ' + $scope.player[2].batteryTime);

			return loadPlayerTwo;

		}(), 1000);

	}


	/*
	*	handle battery field unload action - player 1
	*/
	$scope.playerTwoUnloadBattery = function() {

		// clear timeout (if any from touchstart event)
		clearTimeout($scope.player[2].timeout);

		//	hide charging text
		$scope.player[2].charging = false;

		//	decrease time count every second
		$scope.player[2].timeout = setInterval(function unloadPlayerTwo() {

			if($scope.player[2].batteryTime > 0 && $scope.settings.gameEnabled){

				$scope.player[2].batteryTime = $scope.player[2].batteryTime - 1;
				$scope.player[2].batteryElement.style.height = "calc(4% + " + ($scope.player[2].batteryTime * (100/$scope.settings.maxBatteryTime)) + "%)";

			} else{

				//	deactivate tabs
				$scope.player[2].tapActivated = false;

				//	set height to 0%
				$scope.player[2].batteryElement.style.height = 0;

				clearTimeout($scope.player[2].timeout);

				$scope.$apply();

			}

			//console.log('battery time: ' +$scope.player[1].batteryTime);

			return unloadPlayerTwo;

		}(), 1000);

	}


	/* ==============
  	  HELPER FUNCTIONS
  	  =================*/

	/*
	* get random integer from min and max
	*/
	$scope.getRandomInt = function(min, max) {
	
	  //console.log(min);
	  //console.log(max);
	
	  return Math.floor(Math.random() * ((max - min) + 1) + min);
	}
	
	
	/*
	* check if number is odd (ungerade)
	*/
	$scope.isOdd = function(num) {
		
		return num % 2;
	
	}


	/*
	* on game-view leave (e.g. back to home screen)
	*/
	$scope.$on('$ionicView.afterLeave', function(){

		//	show interstitial
		//if (window.AdMob) AdMob.showInterstitial();

		//  reset game instance
		$scope.gameReset();

	});


	/*
	* change view to home screen
	*/
	$scope.startHomeScreen = function() {

		//	show interstitial
		if (window.AdMob && $scope.settings.showAds) AdMob.showInterstitial();

		//	go to start view
		$state.go('start');

    };

 	/*
	* show interstitial before game screen is left
	*/
    //$scope.$on('$ionicView.beforeLeave', function(e) {
    //    // console.log("leaving");
    //    if (window.AdMob) AdMob.showInterstitial();
    //});
	
	
	
	
	/* ==============
  	  AD FUNCTIONS
  	  =================*/
	// preppare and load ad resource in background, e.g. at begining of game level
	// prepare new ad on dismiss of old one
	document.addEventListener('onAdDismiss', function(data) {
	   if (data.adType == 'interstitial') {
			// preppare and load ad resource in background, e.g. at begining of game level
			if (window.AdMob){
				AdMob.prepareInterstitial( {
					adId: 'ca-app-pub-4543000274312570/5723969446',
					//isTesting:true,//comment this out before publishing the app
					autoShow: false
				} );
				//	resume game from pause
				//alert ('onAdDismiss gamePause: ' + $scope.settings.gamePause);
				$scope.settings.gamePause = false;
				$scope.gameContinue();
			}
		}
	});
	//	Triggered when user click the Ad, and will jump out of your App.
	document.addEventListener('onAdLeaveApp',function(data){
		//	disable Ads, when user has opened one time
		$scope.settings.showAds = false;
	});
	
	



	/* ==============
  	  INIT GAME
  	  =================*/
  $scope.gameInit();
  $scope.gameStart();


})


/*
*	directive to handle long touch events
*/
.directive('myTouchstart', [function() {
	return function(scope, element, attr) {

		element.on('touchstart', function(event) {
			scope.$apply(function() {
				scope.$eval(attr.myTouchstart);
			});
		});
	};
}]).directive('myTouchend', [function() {
	return function(scope, element, attr) {

		element.on('touchend', function(event) {
			scope.$apply(function() {
				scope.$eval(attr.myTouchend);
			});
		});
	};
}]);
